ALTER TABLE [dbo].[TT_Users] DROP [FK_Users_Roles]
GO

DROP TABLE [dbo].[TT_Roles]
GO

CREATE TABLE [dbo].[TT_Roles] (
	[RoleID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Security] [nvarchar] (4000) COLLATE SQL_Latin1_General_CP1_CI_AS  NULL ,
	[Description] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS  NOT NULL ,
	[HourlyRate] [decimal](10, 2) NOT NULL 
)
GO

SET IDENTITY_INSERT [dbo].[TT_Roles] ON
INSERT INTO [dbo].[TT_Roles](RoleID, Name, Security, HourlyRate, Description) VALUES(1,'Administrator', '<security><right name="ViewAllProjects" value="on" /><right name="ViewAllTasks" value="on" /><right name="ViewAllBugs" value="on" /><right name="ViewAllRequests" value="on" /><right name="ViewAllTimeEntries" value="on" /><right name="ViewOwnProjects" value="on" /><right name="ViewOwnTasks" value="on" /><right name="ViewOwnBugs" value="on" /><right name="ViewOwnRequests" value="on" /><right name="ViewOwnTimeEntries" value="on" /><right name="EditAllProjects" value="on" /><right name="EditAllTasks" value="on" /><right name="EditAllBugs" value="on" /><right name="EditAllRequests" value="on" /><right name="EditOwnProjects" value="on" /><right name="EditOwnTasks" value="on" /><right name="EditOwnBugs" value="on" /><right name="EditOwnRequests" value="on" /><right name="DeleteAllProjects" value="on" /><right name="DeleteAllTasks" value="on" /><right name="DeleteAllBugs" value="on" /><right name="DeleteAllRequests" value="on" /><right name="DeleteOwnProjects" value="on" /><right name="DeleteOwnTasks" value="on" /><right name="DeleteOwnBugs" value="on" /><right name="DeleteOwnRequests" value="on" /><right name="AddProjects" value="on" /><right name="AddTasks" value="on" /><right name="AddBugs" value="on" /><right name="AddRequests" value="on" /><right name="AddTimeEntries" value="on" /><right name="ShowCustomerReport" value="on" /><right name="ShowSummaryReport" value="on" /><right name="ShowBugReport" value="on" /><right name="ShowRequestReport" value="on" /><right name="ShowResourceReport" value="on" /><right name="ShowProjectReport" value="on" /><right name="Assign" value="on" /><right name="ManageUsers" value="on" /></security>', 10, 'built-in role')
INSERT INTO [dbo].[TT_Roles](RoleID, Name, Security, HourlyRate, Description) VALUES(2,'Project Manager', '<security><right name="ViewAllProjects" value="off" /><right name="ViewAllTasks" value="on" /><right name="ViewAllBugs" value="on" /><right name="ViewAllRequests" value="on" /><right name="ViewAllTimeEntries" value="on" /><right name="ViewOwnProjects" value="on" /><right name="ViewOwnTasks" value="on" /><right name="ViewOwnBugs" value="on" /><right name="ViewOwnRequests" value="on" /><right name="ViewOwnTimeEntries" value="on" /><right name="EditAllProjects" value="off" /><right name="EditAllTasks" value="on" /><right name="EditAllBugs" value="on" /><right name="EditAllRequests" value="on" /><right name="EditOwnProjects" value="on" /><right name="EditOwnTasks" value="on" /><right name="EditOwnBugs" value="on" /><right name="EditOwnRequests" value="on" /><right name="DeleteAllProjects" value="off" /><right name="DeleteAllTasks" value="on" /><right name="DeleteAllBugs" value="on" /><right name="DeleteAllRequests" value="on" /><right name="DeleteOwnProjects" value="on" /><right name="DeleteOwnTasks" value="on" /><right name="DeleteOwnBugs" value="on" /><right name="DeleteOwnRequests" value="on" /><right name="AddProjects" value="on" /><right name="AddTasks" value="on" /><right name="AddBugs" value="on" /><right name="AddRequests" value="on" /><right name="AddTimeEntries" value="on" /><right name="ShowCustomerReport" value="off" /><right name="ShowSummaryReport" value="on" /><right name="ShowBugReport" value="on" /><right name="ShowRequestReport" value="on" /><right name="ShowResourceReport" value="on" /><right name="ShowProjectReport" value="on" /><right name="Assign" value="on" /><right name="ManageUsers" value="off" /></security>', 10, 'built-in role')
INSERT INTO [dbo].[TT_Roles](RoleID, Name, Security, HourlyRate, Description) VALUES(4,'Customer', '<security><right name="ViewAllProjects" value="off" /><right name="ViewAllTasks" value="off" /><right name="ViewAllBugs" value="off" /><right name="ViewAllRequests" value="off" /><right name="ViewAllTimeEntries" value="off" /><right name="ViewOwnProjects" value="on" /><right name="ViewOwnTasks" value="off" /><right name="ViewOwnBugs" value="on" /><right name="ViewOwnRequests" value="on" /><right name="ViewOwnTimeEntries" value="off" /><right name="EditAllProjects" value="off" /><right name="EditAllTasks" value="off" /><right name="EditAllBugs" value="off" /><right name="EditAllRequests" value="off" /><right name="EditOwnProjects" value="off" /><right name="EditOwnTasks" value="off" /><right name="EditOwnBugs" value="on" /><right name="EditOwnRequests" value="on" /><right name="DeleteAllProjects" value="off" /><right name="DeleteAllTasks" value="off" /><right name="DeleteAllBugs" value="off" /><right name="DeleteAllRequests" value="off" /><right name="DeleteOwnProjects" value="off" /><right name="DeleteOwnTasks" value="off" /><right name="DeleteOwnBugs" value="off" /><right name="DeleteOwnRequests" value="off" /><right name="AddProjects" value="off" /><right name="AddTasks" value="off" /><right name="AddBugs" value="on" /><right name="AddRequests" value="on" /><right name="AddTimeEntries" value="off" /><right name="ShowCustomerReport" value="on" /><right name="ShowSummaryReport" value="off" /><right name="ShowBugReport" value="off" /><right name="ShowRequestReport" value="off" /><right name="ShowResourceReport" value="off" /><right name="ShowProjectReport" value="on" /><right name="Assign" value="off" /><right name="ManageUsers" value="off" /></security>', 10, 'built-in role')
INSERT INTO [dbo].[TT_Roles](RoleID, Name, Security, HourlyRate, Description) VALUES(5,'Developer', '<security><right name="ViewAllProjects" value="off" /><right name="ViewAllTasks" value="off" /><right name="ViewAllBugs" value="off" /><right name="ViewAllRequests" value="off" /><right name="ViewAllTimeEntries" value="off" /><right name="ViewOwnProjects" value="on" /><right name="ViewOwnTasks" value="on" /><right name="ViewOwnBugs" value="on" /><right name="ViewOwnRequests" value="off" /><right name="ViewOwnTimeEntries" value="on" /><right name="EditAllProjects" value="off" /><right name="EditAllTasks" value="off" /><right name="EditAllBugs" value="off" /><right name="EditAllRequests" value="off" /><right name="EditOwnProjects" value="on" /><right name="EditOwnTasks" value="on" /><right name="EditOwnBugs" value="on" /><right name="EditOwnRequests" value="off" /><right name="DeleteAllProjects" value="off" /><right name="DeleteAllTasks" value="off" /><right name="DeleteAllBugs" value="off" /><right name="DeleteAllRequests" value="off" /><right name="DeleteOwnProjects" value="off" /><right name="DeleteOwnTasks" value="off" /><right name="DeleteOwnBugs" value="off" /><right name="DeleteOwnRequests" value="off" /><right name="AddProjects" value="off" /><right name="AddTasks" value="on" /><right name="AddBugs" value="on" /><right name="AddRequests" value="off" /><right name="AddTimeEntries" value="on" /><right name="ShowCustomerReport" value="off" /><right name="ShowSummaryReport" value="off" /><right name="ShowBugReport" value="off" /><right name="ShowRequestReport" value="off" /><right name="ShowResourceReport" value="off" /><right name="ShowProjectReport" value="off" /><right name="Assign" value="off" /><right name="ManageUsers" value="off" /></security>', 10, 'built-in role')
INSERT INTO [dbo].[TT_Roles](RoleID, Name, Security, HourlyRate, Description) VALUES(6,'QA', '<security><right name="ViewAllProjects" value="off" /><right name="ViewAllTasks" value="off" /><right name="ViewAllBugs" value="off" /><right name="ViewAllRequests" value="off" /><right name="ViewAllTimeEntries" value="off" /><right name="ViewOwnProjects" value="on" /><right name="ViewOwnTasks" value="on" /><right name="ViewOwnBugs" value="on" /><right name="ViewOwnRequests" value="off" /><right name="ViewOwnTimeEntries" value="on" /><right name="EditAllProjects" value="off" /><right name="EditAllTasks" value="off" /><right name="EditAllBugs" value="off" /><right name="EditAllRequests" value="off" /><right name="EditOwnProjects" value="off" /><right name="EditOwnTasks" value="on" /><right name="EditOwnBugs" value="on" /><right name="EditOwnRequests" value="off" /><right name="DeleteAllProjects" value="off" /><right name="DeleteAllTasks" value="off" /><right name="DeleteAllBugs" value="off" /><right name="DeleteAllRequests" value="off" /><right name="DeleteOwnProjects" value="off" /><right name="DeleteOwnTasks" value="off" /><right name="DeleteOwnBugs" value="off" /><right name="DeleteOwnRequests" value="off" /><right name="AddProjects" value="off" /><right name="AddTasks" value="on" /><right name="AddBugs" value="on" /><right name="AddRequests" value="off" /><right name="AddTimeEntries" value="on" /><right name="ShowCustomerReport" value="off" /><right name="ShowSummaryReport" value="off" /><right name="ShowBugReport" value="off" /><right name="ShowRequestReport" value="off" /><right name="ShowResourceReport" value="off" /><right name="ShowProjectReport" value="off" /><right name="Assign" value="off" /><right name="ManageUsers" value="off" /></security>', 10, 'built-in role')
SET IDENTITY_INSERT TT_Roles OFF

ALTER TABLE [dbo].[TT_Roles] WITH NOCHECK ADD CONSTRAINT [PK_Roles] PRIMARY KEY  CLUSTERED ( [RoleID] )
GO

ALTER TABLE [dbo].[TT_Users] ADD CONSTRAINT [FK_Users_Roles] FOREIGN KEY ( [RoleID] ) REFERENCES [dbo].[TT_Roles] ( [RoleID] )
GO

CREATE TABLE [dbo].[TT_CustomerDetails] (
    [CustomerID] int NOT NULL IDENTITY(1, 1),
    [UserID] int NOT NULL,
    [CompanyName] nvarchar(100) NOT NULL,
    [Address1] nvarchar(100) NOT NULL,
    [Address2] nvarchar(100) NULL,
    [City] nvarchar(50) NOT NULL,
    [Country] nvarchar(50) NOT NULL,
    [ZIP] nvarchar(25) NOT NULL,
    [Phone1] nvarchar(35) NOT NULL,
    [Phone2] nvarchar(35) NULL,
    [Fax] nvarchar(35) NULL,
    [HourlyRate] decimal(10, 2) NOT NULL,
    [Notes] ntext NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[TT_CustomerDetails] ADD CONSTRAINT [PK_CustomerDetails] PRIMARY KEY ([CustomerID]) ON [PRIMARY]
GO

CREATE TABLE [dbo].[TT_Payments] (
    [PayID] int NOT NULL IDENTITY(1, 1),
    [PayType] int NOT NULL,
    [RelID] int NOT NULL,
    [ProjectID] int NOT NULL,
    [PayDate] datetime NOT NULL,
    [Amount] decimal(10, 2) NOT NULL,
    [Description] ntext NOT NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[TT_Payments] ADD CONSTRAINT [PK_Payments] PRIMARY KEY ([PayID]) ON [PRIMARY]
GO

CREATE TABLE [dbo].[TT_Expenses] (
    [ExpID] int NOT NULL IDENTITY(1, 1),
    [ExpType] int NOT NULL,
    [RelID] int NOT NULL,
    [ProjectID] int NOT NULL,
    [ExpDate] datetime NOT NULL,
    [Amount] decimal(10, 2) NOT NULL,
    [Description] ntext NOT NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[TT_Expenses] ADD CONSTRAINT [PK_Expenses] PRIMARY KEY ([ExpID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[TT_Expenses] ADD CONSTRAINT [FK_TT_Expenses_TT_Projects] FOREIGN KEY ([ProjectID]) REFERENCES [dbo].[TT_Projects] ([ProjectID])  ON DELETE CASCADE
GO

ALTER TABLE [dbo].[TT_Payments] ADD CONSTRAINT [FK_TT_Payments_TT_Projects] FOREIGN KEY ([ProjectID]) REFERENCES [dbo].[TT_Projects] ([ProjectID])  ON DELETE CASCADE
GO

ALTER TABLE [dbo].[TT_Projects] ADD [BillingType] int NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Projects] ADD [Amount] decimal(10, 2) NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Projects] ADD [IncludeTax] bit NOT NULL DEFAULT 0
GO
ALTER TABLE [dbo].[TT_Projects] ADD [TaxAmount] decimal(10, 2) NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Projects] ADD [AutoAssignConfig] ntext NULL
GO

ALTER TABLE [dbo].[TT_EntryLog] ADD [Billable] bit NULL
GO

ALTER TABLE [dbo].[TT_Tasks] ADD [Billable] bit NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Tasks] ADD [BillType] int NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Tasks] ADD [Amount] decimal(10, 2) NOT NULL DEFAULT 0
GO

ALTER TABLE [dbo].[TT_Users] ADD [HourlyRate] decimal(10, 0) NOT NULL DEFAULT 0
GO

alter table [dbo].[tt_options] add [FromName] nvarchar(50) null
go
alter table [dbo].[tt_options] add [FromAddress] nvarchar(50) null
go

update tt_projects set AutoAssignConfig='<autoassign><bugs userID="0" /><requests userID="0" /></autoassign>'

update tt_entrylog set billable=1